<template>
    <div class="map absolute left-0 top-0 w-full h-full">
        <div ref="canvas" class="absolute w-full h-full left-0 top-0 z-10">
            <l-map editable :center="center" :zoom="13" :options="options" v-on:click="click" ref="map">
                <l-circle-marker v-if="found.coordinate" :lat-lng="found.coordinate" :radius="10" color="blue" fillColor='blue'></l-circle-marker>
                <l-tile-layer :url="url" :attribution="attribution" :options="{maxZoom: 20}"></l-tile-layer>
                <v-marker-cluster>
                    <component v-if="featureType(feature)" :is="featureType(feature)" v-for="feature in features" v-bind:key="feature.id" :icon="featureIcon(feature)" :color="placeColor(feature)" :fillColor="placeColor(feature)" :lat-lng="feature.data" :lat-lngs="feature.data" :radius="feature.properties.radius || 100">
                        <l-popup class="p-0 w-56 max-w-56" :class="placePalette(feature.report.type.id, feature).lightest.bg" :options="{'className': 'wee-popup'}">
                            <wee-spatial-info full :feature="feature" v-on:edit="editFeature" :theme="theme" :editable="editable"></wee-spatial-info>
                        </l-popup>
                        <l-tooltip class="">
                            <wee-spatial-info :feature="feature"></wee-spatial-info>
                        </l-tooltip>
                    </component>
                </v-marker-cluster>
                <l-marker v-if="capturing" v-for="(p, i) in captured" :lat-lng="p" :icon="capturedIcon" :theme="theme"></l-marker>
            </l-map>
        </div>
        <div v-if="rendering" class="rendering absolute w-3/4 md:w-56 p-2 z-20 m-auto bg-white rounded-lg bg-gray-800 text-gray-200 opacity-75 text-sm" style="left: 50%; top: 50%; transform: translateY(-50%) translateX(-50%)">
            <p>Rendering {{rendering}} zones ... </p>
            <p>Please wait for a few minutes</p>
        </div>
        <div v-if="capturing" class="absolute z-20 right-0 bottom-0 max-h-full overflow-y-auto">
            <div class="flex flex-col bg-black text-white rounded-sm p-1 opacity-75 h-full max-h-full mb-6 mr-4">
                <div class="w-full text-center text-xs">
                    Capturing Lat Lon in {{capturing}} mode ...
                    <button class="text-teal-100 hover:text-teal-200 bg-transparent font-bold px-1 float-right" v-on:click="clearCaptured()">
                        <img svg-inline src="./pix/zond/trash.svg" alt="done" class="w-4 h-4 mr-1 fill-current" />
                    </button>
                    <button class="text-teal-100 hover:text-teal-200 bg-transparent font-bold px-1 float-right" v-on:click="stopCapturing()">
                        <img svg-inline src="./pix/zond/checkmark.svg" alt="done" class="w-4 h-4 mr-1 fill-current" />
                    </button>
                </div>
                <div class="text-xs border-t flex flex-col flex-grow overflow-y-auto min-h-0 h-full">
                    <div v-for="(p, i) in captured" class="">
                        {{p.lat.toFixed(8)}}, {{p.lng.toFixed(8)}}
                    </div>
                </div>
            </div>
        </div>
        <div class="locate flex flex-col absolute left-0 h-auto min-w-64 z-20 my-4 mx-12">
            <div class="search">
                <div class="editor relative">
                    <input v-model="keyword" type="text" name="keyword" class="text-md w-full rounded-r-lg rounded-bl-lg px-2 py-2" placeholder="search..." v-on:keyup.enter="search" />
                    <img src="./pix/gear.gif" class="absolute right-0 top-0 w-8 mt-1 mr-2" v-if="searching" style="right: 38px;" />
                    <button title="clear" class="absolute right-0 top-0 w-8 mt-1 mr-2" v-on:click="clearSearch">
                        <svg enable-background="new 0 0 320.941 320.941" viewBox="0 0 320.941 320.941" xmlns="http://www.w3.org/2000/svg"><path d="m290.853 40.118h-181.049c-9.06 0-17.551 4.016-23.301 11.038l-84.241 102.968c-3.017 3.692-3.017 9.001 0 12.693l84.251 102.978c5.739 7.013 14.231 11.028 23.291 11.028h181.048c16.592 0 30.088-13.497 30.088-30.088v-180.529c.001-16.592-13.496-30.088-30.087-30.088zm10.029 210.617c0 5.534-4.496 10.029-10.029 10.029h-181.049c-3.026 0-5.857-1.342-7.767-3.673l-79.05-96.621 79.04-96.611c1.92-2.341 4.75-3.683 7.777-3.683h181.048c5.534 0 10.029 4.496 10.029 10.029.001.001.001 180.53.001 180.53z"/><path d="m223.585 103.232-43.056 43.056-43.056-43.056-14.182 14.182 43.056 43.056-43.056 43.056 14.182 14.182 43.056-43.056 43.056 43.056 14.182-14.182-43.056-43.056 43.056-43.056z"/></svg>
                    </button>
                </div>
                <div class="results bg-white">
                    <div class="result border-b-2 border-gray-200 cursor-pointer px-2 py-1 w-full hover:bg-gray-200" v-for="result in results" v-on:click="go(result)">
                        <div class="place text-sm">{{result.name}}</div>
                        <div class="provider text-xs text-gray-400">{{result.provider}}</div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
    import Vue from 'vue'
    import vSelect from 'vue-select'
    import axios from 'axios'
    import axiosCancel from 'axios-cancel';
    import { LMap, LMarker, LPolyline, LPolygon, LTileLayer, LCircle, LCircleMarker, LTooltip, LPopup} from 'vue2-leaflet';
    import 'vue-select/dist/vue-select.css';
    import 'leaflet/dist/leaflet.css';
    import 'leaflet-editable/src/Leaflet.Editable.js';
    import 'leaflet.path.drag/src/Path.Drag.js';
    import './style.css'
    import chroma from 'chroma-js';
    import WeeSpatialInfo from './WeeSpatialInfo';
    import {ThemeMixin} from './themes.js';
    import Vue2LeafletMarkerCluster from 'vue2-leaflet-markercluster'
    const mbp = require('@mapbox/polyline');

    delete L.Icon.Default.prototype._getIconUrl;

    L.Icon.Default.mergeOptions({
        iconRetinaUrl: require('leaflet/dist/images/marker-icon-2x.png'),
        iconUrl: require('leaflet/dist/images/marker-icon.png'),
        shadowUrl: require('leaflet/dist/images/marker-shadow.png'),
    });

    Vue.component('v-select', vSelect);

    axiosCancel(axios, {
        debug: false // default
    });

    const MAPBOX_ACCESS_TOKEN = 'pk.eyJ1IjoibmVlbC1iYXN1IiwiYSI6ImNqNTcwNGttcTByb3UycXBteDV0dGp2dTcifQ.0gpnb7D-LwOTQeGMuO0WXw';
   
    export default {
        name: "WeeSpatialView",
        props: {
            editable: {
                type: Boolean,
                default: false
            },
            project: {
                type: Number,
                required: true
            },
            type: {
                type: String,
                required: true
            },
            lat: {
                type: Number,
                default: 88.363892
            },
            lng: {
                type: Number,
                default: 22.572645
            },
            theme: {
                type: String,
                default: 'teal'
            }
        },
        mixins: [ThemeMixin],
        data: function(){
            let self = this;
            return {
                center: [this.lng, this.lat],
                // url: 'https://api.mapbox.com/styles/v1/neel-basu/ck9tuop9y04tl1il1sj4mw7p2/tiles/{z}/{x}/{y}?access_token='+MAPBOX_ACCESS_TOKEN,
                 url: 'https://mt0.google.com/vt/lyrs=m&x={x}&y={y}&z={z}', // google
                // subdomains:['mt0','mt1','mt2','mt3'], // google
                // attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
                attribution: 'Map data ©2019 Google', // Google
                searching: false,
                options: {
                    editable: true,
                    preferCanvas: true,
                    renderer: L.canvas(),
                    maxZoom: 20
                },
                results: [],
                found : {
                    coordinate: null,
                    name: ''
                },
                capturing: false,
                captured: [],
                capturedIcon: L.icon({
                    iconUrl: '/components/pix/zond/pin.svg',
                    iconSize: [32, 37],
                    iconAnchor: [16, 37]
                }),
                capturingIcon: L.icon({
                    iconUrl: require('./pix/ball.gif'),
                    iconSize: [32, 37],
                    iconAnchor: [16, 37]
                }),
                features: [],
                limit: 4000,
                last: 0,
                rendering: 0
            };
        },
        components: {
            LMap,
            LMarker,
            LPolyline,
            LPolygon,
            LTileLayer,
            LCircle,
            LCircleMarker,
            LTooltip,
            LPopup,
            WeeSpatialInfo,
            'v-marker-cluster': Vue2LeafletMarkerCluster
        },
        created: function(){
            this.selectionColors = chroma.scale(['#fafa6e','#2A4858']).mode('lch').colors(60);
            this.selectionTimer  = null;
            console.log('usig canvas renderrer 2');
        },
        mounted: function(){
            let self = this;
            this.$nextTick(() => {
                self.reload();
                self.init(this.$refs.map.mapObject);
            });
        },
        methods: {
            init(map){
                let self = this;
                this._map   = map;
                this._route = null;
                this._map.on('editable:vertex:new editable:vertex:deleted editable:vertex:dragend editable:dragend', function(e){
                    self.altered();
                });
            },
            altered(){
                if((this.capturing == 'multiple') && this._route){
                    this.captured = this._route.getLatLngs().map(function(l){
                        return {lat: l.lat, lng: l.lng};
                    });
                }
            },
            search(){
                let self = this;
                this.searching = true;
                axios.get(this.searchUrl+this.keyword).then(function(response){
                    self.results = response.data.results;
                    self.searching = false;
                }).catch((thrown) => function(){
                    self.searching = false;
                });
            },
            clearSearch(){
                this.results = [];
                this.keyword = "";
                this.found.coordinate = null;
            },
            go(result){
                this.found = result;
                this.focus(result.coordinate);
            },
            reload(){
                let self = this;
                axios.get(this.featuresUrl).then(function(response){
                    let render = function(i){
                        //setTimeout(function(){
                            let j = i;
                            for(; j < response.data.places.length; ++j){
                                self.features.push(response.data.places[j]);
                                if(j >= i+500){
                                    break;
                                }
                            }
                            if(j+1 < response.data.places.length){
                                render(j+1);
                            }else{
                                if(response.data.count > 0){
                                    self.last = response.data.range.end;
                                    self.reload();
                                }
                            }
                        //}, 100);
                    }
                    if(response.data.count > 0){
                        // render(0);
                        console.log("rendering started", response.data.count, new Date);
                        self.rendering = response.data.count;
                        setTimeout(function(){
                            self.features  = response.data.places;
                            self.last = response.data.range.end;
                            self.reload();
                        }, 50);
                    }else{
                        console.log("rendering ended", new Date);
                        self.rendering = 0;
                    }
                    // console.log(self.features);
                }).catch((thrown) => function(){
                    
                });
            },
            click(e){
                if(!this.capturing){
                    return;
                }
                if(this.capturing == 'single'){
                    this.clearCaptured();
                    this.captured.push(e.latlng);
                }else if(this.capturing == 'multiple'){
                    if(this._route){
                        return;
                    }
                    this._route = this._map.editTools.startPolyline(e.latlng);
                }
            },
            focus(coordinate){
                this.$refs.map.mapObject.flyTo(coordinate, 18);
            },
            query(place){
                this.clearSearch();
                this.keyword = place;
                this.search();
            },
            startCapturing(mode){
                this.capturing = mode;
            },
            stopCapturing(){
                console.log('selected', this.captured);
                this.capturing = false;
                this.$emit('selected', this.captured);
                this.clearCaptured();
                this.$emit('captured');
            },
            clearCaptured(){
                this.captured = [];
                if(this._route){
                    this._route.remove();
                    this._route = null;
                }
            },
            featureType(feature){
                if(feature.type == 'point'){
                    return 'LMarker';
                }else if(feature.type == 'polyline'){
                    return 'LPolyline';
                }else if(feature.type == 'circle'){
                    return 'LCircle';
                }else if(feature.type == 'polygon'){
                    return 'LPolygon';
                }
                return null;
            },
            editFeature(id){
                console.log('WeeSpatialview::editFeature', id);
                this.$emit('edit', id);
            },
            makeEditable(id){
                let self = this;
                for(const idx in self.features){
                    const feature = self.features[idx];
                    if(feature.id == id){
                        console.log("making editable", feature.data);
                        const locations = Array.isArray(feature.data) ? feature.data : [feature.data];
                        self.captured = locations;
                        if(feature.type == 'polyline'){
                            self._route = L.polyline(locations).addTo(self.$refs.map.mapObject);
                            self._route.enableEdit();
                        }
                        break;
                    }
                }
            },
            update(id){
                let self = this;
                axios.get(this.featureUrl+id).then(function(response){
                    for(const idx in self.features){
                        const feature = self.features[idx];
                        if(feature.id == id){
                            Vue.set(self.features, idx, response.data.place);
                            break;
                        }
                    }
                    // console.log(self.features);
                }).catch((thrown) => function(err){
                    console.log(err);
                });
            },
            remove(id){
                let self = this;
                for(const idx in self.features){
                    const feature = self.features[idx];
                    if(feature.id == id){
                        Vue.delete(self.features, idx);
                        break;
                    }
                }
            },
            featureIcon(feature){
                if(feature.type == 'point'){
                    const palette = this.placePalette(feature.report.type.id, feature);
                    const iconData = 'data:image/svg+xml;utf8,'+'<svg xmlns="http://www.w3.org/2000/svg" class="fill-current text-red-600" viewBox="0 0 20 20"><path d="M10 20S3 10.87 3 7a7 7 0 1 1 14 0c0 3.87-7 13-7 13zm0-11a2 2 0 1 0 0-4 2 2 0 0 0 0 4z"/></svg>';
                    return L.divIcon({
                        html: '<svg xmlns="http://www.w3.org/2000/svg" class="fill-current w-8 h-8" viewBox="0 0 20 20"><path d="M10 20S3 10.87 3 7a7 7 0 1 1 14 0c0 3.87-7 13-7 13zm0-11a2 2 0 1 0 0-4 2 2 0 0 0 0 4z"/></svg>',
                        className: 'fill-current '+palette.darker.text
                    });
                }
                return null;
            },
            placeColor(feature){
                return this.placePalette(feature.report.type.id, feature).darker.color;
            }
        },
        computed: {
            searchUrl(){
                return "/spatial/search/";
            },
            featuresUrl(){
                if(this.type){
                    return '/places/fetch/'+this.project+'/'+this.type+'/'+this.limit+'/'+this.last;
                }else{
                    return '/places/fetch/'+this.project+'/'+this.limit+'/'+this.last;
                }
            },
            featureUrl(){
                return "/places/";
            }
        }
    }
</script>
<style>
    @import "~leaflet.markercluster/dist/MarkerCluster.css";
    @import "~leaflet.markercluster/dist/MarkerCluster.Default.css";
    .map{
        width: 100%;
        height: 100%;
    }
    .canvas{
        width: 100%;
        height: 100%;
    }
    .tab-regular{
        @apply bg-white inline-block py-1 px-2 text-blue-500 font-semibold
    }
    .tab-active{
        @apply bg-white inline-block py-1 px-2 text-blue-700 font-semibold border-l border-t border-r rounded-t
    }
    .wee-popup{
        padding: 0px !important;
        margin: 0px !important;
    }
    .wee-popup .leaflet-popup-tip-container{
        bottom: -16px;
    }
    .wee-popup .leaflet-popup-tip{
        @apply bg-teal-200
    }
    .wee-popup .leaflet-popup-content-wrapper{
        padding: 0px !important;
        margin: 0px !important;
    }
    .wee-popup .leaflet-popup-content{
        padding: 0px !important;
        margin: 0px !important;
    }
</style>
